Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/SymbolicRegressionSolutionLinearScaler.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/SymbolicRegressionSolutionLinearScaler.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/SymbolicRegressionSolutionLinearScaler.cs	(revision 5177)
@@ -69,5 +69,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       SymbolicExpressionTree tree = SymbolicExpressionTreeParameter.ActualValue;
       DoubleValue alpha = AlphaParameter.ActualValue;
@@ -80,5 +80,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/SymbolicRegressionVariableFrequencyAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/SymbolicRegressionVariableFrequencyAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Analyzers/SymbolicRegressionVariableFrequencyAnalyzer.cs	(revision 5177)
@@ -76,5 +76,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<SymbolicExpressionTree> expressions = SymbolicExpressionTreeParameter.ActualValue;
       DataAnalysisProblemData problemData = ProblemDataParameter.ActualValue;
@@ -99,5 +99,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/MultiObjectiveSymbolicRegressionEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/MultiObjectiveSymbolicRegressionEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/MultiObjectiveSymbolicRegressionEvaluator.cs	(revision 5177)
@@ -118,5 +118,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int seed = Random.Next();
       IEnumerable<int> rows = SingleObjectiveSymbolicRegressionEvaluator.GenerateRowsToEvaluate(seed, RelativeNumberOfEvaluatedSamples.Value, SamplesStart.Value, SamplesEnd.Value)
@@ -125,5 +125,5 @@
         RegressionProblemData.TargetVariable, rows);
       QualitiesParameter.ActualValue = new DoubleArray(qualities);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SingleObjectiveSymbolicRegressionEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SingleObjectiveSymbolicRegressionEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SingleObjectiveSymbolicRegressionEvaluator.cs	(revision 5177)
@@ -144,13 +144,13 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int seed = Random.Next();
       IEnumerable<int> rows = GenerateRowsToEvaluate(seed, RelativeNumberOfEvaluatedSamples.Value, SamplesStart.Value, SamplesEnd.Value)
           .Where(i => i < RegressionProblemData.TestSamplesStart.Value || RegressionProblemData.TestSamplesEnd.Value <= i);
-      double quality = Evaluate(SymbolicExpressionTreeInterpreter, SymbolicExpressionTree, LowerEstimationLimit.Value, UpperEstimationLimit.Value,
+      double quality = Evaluate(context, SymbolicExpressionTreeInterpreter, SymbolicExpressionTree, LowerEstimationLimit.Value, UpperEstimationLimit.Value,
         RegressionProblemData.Dataset,
         RegressionProblemData.TargetVariable.Value, rows);
       QualityParameter.ActualValue = new DoubleValue(quality);
-      return base.Apply();
+      return base.Apply(context);
     }
 
@@ -163,5 +163,6 @@
     }
 
-    public abstract double Evaluate(ISymbolicExpressionTreeInterpreter interpreter,
+    public abstract double Evaluate(IExecutionContext context,
+      ISymbolicExpressionTreeInterpreter interpreter,
       SymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit,
       Dataset dataset,
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionMeanSquaredErrorEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionMeanSquaredErrorEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionMeanSquaredErrorEvaluator.cs	(revision 5177)
@@ -45,5 +45,5 @@
     }
 
-    public override double Evaluate(ISymbolicExpressionTreeInterpreter interpreter, SymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit, Dataset dataset, string targetVariable, IEnumerable<int> rows) {
+    public override double Evaluate(IExecutionContext context, ISymbolicExpressionTreeInterpreter interpreter, SymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit, Dataset dataset, string targetVariable, IEnumerable<int> rows) {
       double mse = Calculate(interpreter, solution, lowerEstimationLimit, upperEstimationLimit, dataset, targetVariable, rows);
       return mse;
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionPearsonsRSquaredEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionPearsonsRSquaredEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionPearsonsRSquaredEvaluator.cs	(revision 5177)
@@ -43,5 +43,5 @@
       return new SymbolicRegressionPearsonsRSquaredEvaluator(this, cloner);
     }
-    public override double Evaluate(ISymbolicExpressionTreeInterpreter interpreter, SymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit, Dataset dataset, string targetVariable, IEnumerable<int> rows) {
+    public override double Evaluate(IExecutionContext context, ISymbolicExpressionTreeInterpreter interpreter, SymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit, Dataset dataset, string targetVariable, IEnumerable<int> rows) {
       double mse = Calculate(interpreter, solution, lowerEstimationLimit, upperEstimationLimit, dataset, targetVariable, rows);
       return mse;
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionScaledMeanAndVarianceSquaredErrorEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionScaledMeanAndVarianceSquaredErrorEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionScaledMeanAndVarianceSquaredErrorEvaluator.cs	(revision 5177)
@@ -109,5 +109,5 @@
     }
 
-    public override double Evaluate(ISymbolicExpressionTreeInterpreter interpreter, SymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit, Dataset dataset, string targetVariable, IEnumerable<int> rows) {
+    public override double Evaluate(IExecutionContext context, ISymbolicExpressionTreeInterpreter interpreter, SymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit, Dataset dataset, string targetVariable, IEnumerable<int> rows) {
       double alpha, beta;
       double meanSE, varianceSE;
@@ -115,5 +115,5 @@
       double bias, variance, covariance;
       double mse;
-      if (ExecutionContext != null) {
+      if (context != null) {
         if (ApplyScaling.Value) {
           mse = Calculate(interpreter, solution, lowerEstimationLimit, upperEstimationLimit, dataset, targetVariable, rows, out beta, out alpha, out meanSE, out varianceSE, out count, out bias, out variance, out covariance);
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionScaledMeanSquaredErrorEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionScaledMeanSquaredErrorEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Evaluators/SymbolicRegressionScaledMeanSquaredErrorEvaluator.cs	(revision 5177)
@@ -67,8 +67,8 @@
     }
 
-    public override double Evaluate(ISymbolicExpressionTreeInterpreter interpreter, SymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit, Dataset dataset, string targetVariable, IEnumerable<int> rows) {
+    public override double Evaluate(IExecutionContext context, ISymbolicExpressionTreeInterpreter interpreter, SymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit, Dataset dataset, string targetVariable, IEnumerable<int> rows) {
       double alpha, beta;
       double mse = Calculate(interpreter, solution, lowerEstimationLimit, upperEstimationLimit, dataset, targetVariable, rows, out beta, out alpha);
-      if (ExecutionContext != null) {
+      if (context != null) {
         AlphaParameter.ActualValue = new DoubleValue(alpha);
         BetaParameter.ActualValue = new DoubleValue(beta);
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Interfaces/ISymbolicRegressionEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Interfaces/ISymbolicRegressionEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/Interfaces/ISymbolicRegressionEvaluator.cs	(revision 5177)
@@ -38,5 +38,5 @@
 
 
-    double Evaluate(ISymbolicExpressionTreeInterpreter interpreter, SymbolicExpressionTree tree,
+    double Evaluate(IExecutionContext context, ISymbolicExpressionTreeInterpreter interpreter, SymbolicExpressionTree tree,
           double lowerEstimationLimit, double upperEstimationLimit,
           Dataset dataset, string targetVariable, IEnumerable<int> rows);
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/SimpleSymbolicRegressionEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/SimpleSymbolicRegressionEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/SimpleSymbolicRegressionEvaluator.cs	(revision 5177)
@@ -120,5 +120,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       Dataset dataset = RegressionProblemData.Dataset;
       string targetVariable = RegressionProblemData.TargetVariable.Value;
@@ -136,5 +136,5 @@
       // NB: indexes must match SimpleEvaluator.ORIGINAL_INDEX and SimpleEvaluator.ESTIMATED_INDEX
       ValuesParameter.ActualValue = new DoubleMatrix(MatrixExtensions<double>.Create(originalValues.ToArray(), estimatedValues.ToArray()));
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/Evaluators/SimpleEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/Evaluators/SimpleEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/Evaluators/SimpleEvaluator.cs	(revision 5177)
@@ -45,8 +45,8 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       DoubleMatrix values = ValuesParameter.ActualValue;
       Apply(values);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/SupportVectorMachineCrossValidationEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/SupportVectorMachineCrossValidationEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/SupportVectorMachineCrossValidationEvaluator.cs	(revision 5177)
@@ -154,5 +154,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       double reductionRatio = 1.0; // TODO: make parameter
       if (ActualSamplesParameter.ActualValue != null)
@@ -177,5 +177,5 @@
 
       QualityParameter.ActualValue = new DoubleValue(quality);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/SupportVectorMachineModelCreator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/SupportVectorMachineModelCreator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/SupportVectorMachineModelCreator.cs	(revision 5177)
@@ -133,5 +133,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int start = SamplesStart.Value;
       int end = SamplesEnd.Value;
@@ -146,5 +146,5 @@
       SupportVectorMachineModelParameter.ActualValue = model;
 
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/SupportVectorMachineModelEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/SupportVectorMachineModelEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/SupportVectorMachineModelEvaluator.cs	(revision 5177)
@@ -87,5 +87,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int start = SamplesStart.Value;
       int end = SamplesEnd.Value;
@@ -95,5 +95,5 @@
 
       ValuesParameter.ActualValue = new DoubleMatrix(Evaluate(SupportVectorMachineModel, DataAnalysisProblemData, rows));
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/VariableFrequencyAnalyser.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/VariableFrequencyAnalyser.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.DataAnalysis/3.3/Symbolic/VariableFrequencyAnalyser.cs	(revision 5177)
@@ -74,5 +74,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       var inputVariables = DataAnalysisProblemData.InputVariables.CheckedItems.Select(x => x.Value.Value);
       if (VariableFrequencies == null) {
@@ -86,5 +86,5 @@
         VariableFrequencies[lastRowIndex, columnIndex] = pair.Value;
       }
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluator.cs	(revision 5177)
@@ -60,5 +60,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       IEvaluationServiceClient client = ClientParameter.ActualValue;
       SolutionMessage.Builder protobufBuilder = SolutionMessage.CreateBuilder();
@@ -82,5 +82,5 @@
       else QualityParameter.ActualValue.Value = answer.Quality;
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.Knapsack/3.3/Analyzers/BestKnapsackSolutionAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.Knapsack/3.3/Analyzers/BestKnapsackSolutionAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.Knapsack/3.3/Analyzers/BestKnapsackSolutionAnalyzer.cs	(revision 5177)
@@ -90,5 +90,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<BinaryVector> binaryVectors = BinaryVectorParameter.ActualValue;
       ItemArray<DoubleValue> qualities = QualityParameter.ActualValue;
@@ -126,5 +126,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.Knapsack/3.3/Evaluators/KnapsackEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.Knapsack/3.3/Evaluators/KnapsackEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.Knapsack/3.3/Evaluators/KnapsackEvaluator.cs	(revision 5177)
@@ -129,5 +129,5 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       BinaryVector v = BinaryVectorParameter.ActualValue;
 
@@ -143,5 +143,5 @@
       AppliedPenaltyParameter.ActualValue = evaluation.AppliedPenalty;
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.Knapsack/3.3/MoveEvaluators/KnapsackOneBitflipMoveEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.Knapsack/3.3/MoveEvaluators/KnapsackOneBitflipMoveEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.Knapsack/3.3/MoveEvaluators/KnapsackOneBitflipMoveEvaluator.cs	(revision 5177)
@@ -50,5 +50,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       BinaryVector binaryVector = BinaryVectorParameter.ActualValue;
       OneBitflipMove move = OneBitflipMoveParameter.ActualValue;
@@ -67,5 +67,5 @@
       if (MoveQualityParameter.ActualValue == null) MoveQualityParameter.ActualValue = new DoubleValue(moveQuality);
       else MoveQualityParameter.ActualValue.Value = moveQuality;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.OneMax/3.3/Analyzers/BestOneMaxSolutionAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.OneMax/3.3/Analyzers/BestOneMaxSolutionAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.OneMax/3.3/Analyzers/BestOneMaxSolutionAnalyzer.cs	(revision 5177)
@@ -73,5 +73,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<BinaryVector> binaryVectors = BinaryVectorParameter.ActualValue;
       ItemArray<DoubleValue> qualities = QualityParameter.ActualValue;
@@ -104,5 +104,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.OneMax/3.3/Evaluators/OneMaxEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.OneMax/3.3/Evaluators/OneMaxEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.OneMax/3.3/Evaluators/OneMaxEvaluator.cs	(revision 5177)
@@ -56,5 +56,5 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       BinaryVector v = BinaryVectorParameter.ActualValue;
 
@@ -67,5 +67,5 @@
       QualityParameter.ActualValue = new DoubleValue(quality);
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.OneMax/3.3/MoveEvaluators/OneMaxOneBitflipMoveEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.OneMax/3.3/MoveEvaluators/OneMaxOneBitflipMoveEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.OneMax/3.3/MoveEvaluators/OneMaxOneBitflipMoveEvaluator.cs	(revision 5177)
@@ -50,5 +50,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       BinaryVector binaryVector = BinaryVectorParameter.ActualValue;
       OneBitflipMove move = OneBitflipMoveParameter.ActualValue;
@@ -62,5 +62,5 @@
       if (MoveQualityParameter.ActualValue == null) MoveQualityParameter.ActualValue = new DoubleValue(moveQuality);
       else MoveQualityParameter.ActualValue.Value = moveQuality;
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/Analyzers/BestSingleObjectiveTestFunctionSolutionAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/Analyzers/BestSingleObjectiveTestFunctionSolutionAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/Analyzers/BestSingleObjectiveTestFunctionSolutionAnalyzer.cs	(revision 5177)
@@ -102,5 +102,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       ItemArray<RealVector> realVectors = RealVectorParameter.ActualValue;
       ItemArray<DoubleValue> qualities = QualityParameter.ActualValue;
@@ -137,5 +137,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/SingleObjectiveTestFunctionProblemEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/SingleObjectiveTestFunctionProblemEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/SingleObjectiveTestFunctionProblemEvaluator.cs	(revision 5177)
@@ -82,9 +82,9 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       RealVector point = PointParameter.ActualValue;
       double quality = EvaluateFunction(point);
       QualityParameter.ActualValue = new DoubleValue(quality);
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/AdditiveMoveEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/AdditiveMoveEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/AdditiveMoveEvaluator.cs	(revision 5177)
@@ -63,5 +63,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       double mq = Evaluate(QualityParameter.ActualValue.Value, RealVectorParameter.ActualValue, AdditiveMoveParameter.ActualValue);
       DoubleValue moveQuality = MoveQualityParameter.ActualValue;
@@ -69,5 +69,5 @@
         MoveQualityParameter.ActualValue = new DoubleValue(mq);
       } else moveQuality.Value = mq;
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/RealVectorToRealVectorEncoder.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/RealVectorToRealVectorEncoder.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.TestFunctions/3.3/RealVectorToRealVectorEncoder.cs	(revision 5177)
@@ -73,9 +73,9 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       RealVectorParameter.ActualValue = OriginalRealVectorParameter.ActualValue;
       IItem value = (IItem)BoundsParameter.ActualValue.Clone();
       CurrentScope.Variables.Add(new Variable("ParticleBounds", BoundsParameter.Description, value == null ? null : (IItem)value.Clone()));
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.TravelingSalesman/3.3/Analyzers/BestTSPSolutionAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.TravelingSalesman/3.3/Analyzers/BestTSPSolutionAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.TravelingSalesman/3.3/Analyzers/BestTSPSolutionAnalyzer.cs	(revision 5177)
@@ -80,5 +80,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       DoubleMatrix coordinates = CoordinatesParameter.ActualValue;
       ItemArray<Permutation> permutations = PermutationParameter.ActualValue;
@@ -114,5 +114,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.TravelingSalesman/3.3/Evaluators/TSPCoordinatesPathEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.TravelingSalesman/3.3/Evaluators/TSPCoordinatesPathEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.TravelingSalesman/3.3/Evaluators/TSPCoordinatesPathEvaluator.cs	(revision 5177)
@@ -71,5 +71,5 @@
     }
 
-    public sealed override IOperation Apply() {
+    public sealed override IOperation Apply(IExecutionContext context) {
       if (UseDistanceMatrixParameter.ActualValue.Value) {
         Permutation p = PermutationParameter.ActualValue;
@@ -102,5 +102,5 @@
         QualityParameter.ActualValue = new DoubleValue(length);
       }
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/TSPPathMoveEvaluator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/TSPPathMoveEvaluator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/TSPPathMoveEvaluator.cs	(revision 5177)
@@ -71,5 +71,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       Permutation permutation = PermutationParameter.ActualValue;
       DoubleMatrix coordinates = CoordinatesParameter.ActualValue;
@@ -86,5 +86,5 @@
       if (moveQuality == null) MoveQualityParameter.ActualValue = new DoubleValue(QualityParameter.ActualValue.Value + relativeQualityDifference);
       else moveQuality.Value = QualityParameter.ActualValue.Value + relativeQualityDifference;
-      return base.Apply();
+      return base.Apply(context);
     }
 
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Analyzers/BestAverageWorstVRPToursCalculator.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Analyzers/BestAverageWorstVRPToursCalculator.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Analyzers/BestAverageWorstVRPToursCalculator.cs	(revision 5177)
@@ -243,5 +243,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       UpdateOverloads();
       UpdateTardiness();
@@ -250,5 +250,5 @@
       UpdateVehiclesUtilized();
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Analyzers/BestVRPSolutionAnalyzer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Analyzers/BestVRPSolutionAnalyzer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Analyzers/BestVRPSolutionAnalyzer.cs	(revision 5177)
@@ -132,5 +132,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       DoubleMatrix coordinates = CoordinatesParameter.ActualValue;
       ItemArray<IVRPEncoding> solutions = VRPToursParameter.ActualValue;
@@ -188,5 +188,5 @@
       }
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
Index: /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Analyzers/BestVRPToursMemorizer.cs
===================================================================
--- /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Analyzers/BestVRPToursMemorizer.cs	(revision 5176)
+++ /branches/ParallelEngine/HeuristicLab.Problems.VehicleRouting/3.3/Analyzers/BestVRPToursMemorizer.cs	(revision 5177)
@@ -89,5 +89,5 @@
     }
 
-    public override IOperation Apply() {
+    public override IOperation Apply(IExecutionContext context) {
       int i = OverloadParameter.ActualValue.Select((x, index) => new { index, x.Value }).OrderBy(x => x.Value).First().index;
       if (BestOverloadParameter.ActualValue == null)
@@ -120,5 +120,5 @@
         BestVehiclesUtilizedParameter.ActualValue.Value = VehiclesUtilizedParameter.ActualValue[i].Value;
 
-      return base.Apply();
+      return base.Apply(context);
     }
   }
